
yarip.Observer = function(control, type, prefRoot, preference)
{
	this.control = control ? control : null;
	this.type = type ? type : "";
	this.prefRoot = prefRoot ? prefRoot : "";
	this.preference = preference ? preference : "";
	this.observable = null;
	this.enabled = true;

	this.register = function()
	{
		this.observable = this.control.prefService.getBranch(this.prefRoot);
		this.observable.QueryInterface(Components.interfaces.nsIPrefBranch2);
		this.observable.addObserver("", this, false);
	}

	this.unregister = function()
	{
		if (this.observable) this.observable.removeObserver("", this);
	}

	this.observe = function(aSubject, aTopic, aData)
	{
		if (this.enabled && aData == this.preference) this.control.update(this.type);
	}

	this.enable = function()
	{
		this.enabled = true;
	}

	this.disable = function()
	{
		this.enabled = false;
	}
}
